package de.uni_potsdam.hpi.gds.digisim.plugin;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.beans.PropertyVetoException;
import java.util.HashMap;
import java.util.Map;

import de.ksquared.jds.components.Component;
import de.ksquared.jds.components.Configurable;
import de.ksquared.jds.components.Configurable.Option.OptionType;


public class GroupArea extends Component implements Configurable
{
	
	private static final long serialVersionUID = -144962928848278098L;
	
	private int height = 50;
	private int width = 50;
	private String name = "Gruppe";


	
	public static final ComponentAttributes componentAttributes = 
		new ComponentAttributes("Gruppierung",
										"group.general",
										"Gruppierung",
										"Daniel Kurzynski",
										1);

	public GroupArea()
	{

	}
	
	
	@Override
	public Dimension getSize()
	{
		return new Dimension(this.width+10, this.height+25);	
	}
	
	
	@Override
	public void paint(Graphics graphics)
	{
		graphics.setColor(Color.BLACK);
		graphics.drawRect(5, 15, this.width, this.height);

		graphics.drawString(name, 10, 10);
	}
	
	
	@Override
	public void calculate()
	{
		
	}
	
	
	@Override
	public Map<Option, Object> getConfiguration()
	{
		Option[] options = getOptions();
		Map<Option,Object> configuration = new HashMap<Option,Object>(); 
		configuration.put(options[0],height);
		configuration.put(options[1],width);
		configuration.put(options[2],name);
		return configuration;
	}
	
	
	@Override
	public Option[] getOptions()
	{
		return new Option[]{
				new Option("height","Höhe",OptionType.NUMBER,50),
				new Option("width","Breite",OptionType.NUMBER,50),
				new Option("name","Bezeichnung",OptionType.TEXT,"Gruppe")
				};
	}
	
	
	@Override
	public void setConfiguration(Map<Option, Object> configuration)
			throws PropertyVetoException
	{	
		Option[] options = getOptions();
		
		int newHeight = (Integer) configuration.get(options[0]);
		if (newHeight < 50)
			/** throw a new veto exception to cancel this method */
			throw new PropertyVetoException(
					"Das Feld muss mindestens die Höhe 50 haben", null);
		
		this.height = newHeight; 
		
		int newWidth = (Integer) configuration.get(options[1]);
		if (newWidth < 50)
			/** throw a new veto exception to cancel this method */
			throw new PropertyVetoException(
					"Das Feld muss mindestens die Breite 50 haben", null);
		
		this.width = newWidth;
		
		this.name = (String) configuration.get(options[2]);
		
	}
}
