package de.uni_potsdam.hpi.gds.digisim.plugin;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import de.ksquared.jds.components.Component;
import de.ksquared.jds.components.Sociable;
import de.ksquared.jds.contacts.Contact;
import de.ksquared.jds.contacts.ContactList;
import de.ksquared.jds.contacts.InputContact;

public class Hexanzeige extends Component implements Sociable
{

	private static final long serialVersionUID = -8968397903792300746L;
	
	public static final ComponentAttributes componentAttributes = 
		new ComponentAttributes("Hexanzeige",
										"group.display",
										"Hexanzeige",
										"Johannes Linke",
										1);
	
	private ContactList<InputContact> inputs;
	
	private char currChar = '0';
	
	
	public Hexanzeige()
	{
		inputs = new ContactList<InputContact>(this, InputContact.class, 4);
	}
	
	
	@Override
	public Dimension getSize()
	{
		return new Dimension(50, 50);
	}
	
	
	@Override
	public void paint(Graphics graphics)
	{
		Dimension size = getSize();
		Font previousFont = graphics.getFont();
		graphics.setFont(new Font(previousFont.getName(), previousFont.getStyle(), 50));
		graphics.setColor(Color.BLACK);
		
		graphics.drawRect(5, 0, size.width - 5, size.height);
		graphics.drawString(""+currChar, getSize().width/2+2-graphics.getFontMetrics().stringWidth(""+currChar)/2, size.height - 5);
		
		graphics.setFont(previousFont);
	}
	
	
	@Override
	public Contact[] getContacts()
	{
		return inputs.toArray();
	}

	@Override
	public void calculate()
	{
		int input = inputSignalToInt();
		if (input < 10)
			currChar = (char)(input + 48);
		else
			currChar = (char)(input + 55);
	}
	
	
	private int inputSignalToInt()
	{
		int a = 0;
		int b= 0;
		for (InputContact x: inputs) {
			if (x.isCharged()) {
				a = a + (int) Math.pow(2, b);
			}
			b++;
		}
		return a;
	}
}
